unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    BStartStop: TButton;
    UpDown1: TUpDown;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    procedure BStartStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Chart, Series, TeePNG;

procedure TForm1.BStartStopClick(Sender: TObject);
var chart: TChart;
    i: Integer;
begin
  if BStartStop.Caption='Start' then
  begin
    BStartStop.Caption:='Stop';
    ProgressBar1.Position:=0;
    ProgressBar1.Max:=UpDown1.Position-1;
    for i:=1 to UpDown1.Position do
    begin
      if BStartStop.Caption='Start' then
         Exit;

      chart:=TChart.Create(nil);
      with TBarSeries(chart.AddSeries(TBarSeries)) do
      begin
        Color:=OperaPalette[(i-1) mod Length(OperaPalette)];
        FillSampleValues;
      end;

      TeeSaveToPNG(chart, Edit2.Text+'\Chart'+IntToStr(i)+'.png');
      chart.Free;

      StatusBar1.Panels[0].Text:=IntToStr(i)+'/'+IntToStr(UpDown1.Position);
      ProgressBar1.Position:=i;
      Application.ProcessMessages;
    end;
    BStartStop.Caption:='Start';
  end
  else
    BStartStop.Caption:='Start';
end;

procedure TForm1.Button2Click(Sender: TObject);
var OpenDialog: TFileOpenDialog;
begin
  OpenDialog:=TFileOpenDialog.Create(Self);
  try
    OpenDialog.Options:=OpenDialog.Options+[fdoPickFolders];
    if not OpenDialog.Execute then
      Abort;
    Edit2.Text:=OpenDialog.FileName;
  finally
    OpenDialog.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var  ProgressBarStyle: integer;
begin
  UpDown1.Max:=1500;
  UpDown1.Position:=1000;
  Edit2.Text:='F:\Downloads\png_export';

  StatusBar1.Panels[1].Style:=psOwnerDraw;
  ProgressBar1.Parent:=StatusBar1;
  ProgressBarStyle:=GetWindowLong(ProgressBar1.Handle, GWL_EXSTYLE);
  ProgressBarStyle:=ProgressBarStyle-WS_EX_STATICEDGE;
  SetWindowLong(ProgressBar1.Handle, GWL_EXSTYLE, ProgressBarStyle);
end;

procedure TForm1.StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin
  if Panel = StatusBar.Panels[1] then
    with ProgressBar1 do
    begin
      Top:=Rect.Top;
      Left:=Rect.Left;
      Width:=Rect.Right-Rect.Left-15;
      Height:=Rect.Bottom-Rect.Top;
    end;
end;

end.
